#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

extern double dt;


int spectrum(double *msd,int npts,float **spect)
{
    int i,j,k,N1,Ntape;
    float tape,delta; 
    float *odata,*ds,*de; 
    N1 = 1;
    while(N1<npts) N1 *=2;
    N1 /= 2;
    Ntape = N1/20;       // 5 % of total

    delta = 2.*dt/(float)N1;

    odata = (float *)malloc(N1*2*sizeof(float));
    for(i=0;i<N1*2;i++) odata[i] = 0.;

    *spect = (float *)malloc(N1/2*sizeof(float));

    for(i=0; i<N1; i++)
	odata[i] = msd[i];
    ds = odata;
    de = odata+i-1;

    for(j=0;j<Ntape;j++)
    {
	tape = .5 - .5 * cos((M_PI*(float)(j)/(float)(Ntape)));
	*ds *= tape;
	*de *= tape;
	ds++;
	de--;
    }

    ds = odata;
    de = odata+N1;
//    cfftr(ds,N1);

    FFT(-1,N1,&ds,&de);

    for(i=0; i<N1/2; i++)
    {
	(*spect)[i] = delta*(ds[i]*ds[i]+de[i]*de[i]);
    }

    free(odata);
    return N1;
}

